import java.io.*;

public class Game {

	final int SPALTEN = 10;
	final int ZEILEN  = 8;
	BufferedReader in = new BufferedReader(new InputStreamReader(System.in));

	Topf topf = null;
	Spielfeld feld = null;

	/** Initialisiert alle Variablen
	 */
	public void init() {
		int steineProSpieler = SPALTEN*ZEILEN / 2;
		topf = (Topf) new MyTopf(steineProSpieler);
		feld = (Spielfeld) new MySpielfeld(SPALTEN,ZEILEN);
	}

	/** Main. Initialisieren und start des Spiels.*/
	public static void main(String[] args) {
		Game game = new Game();
		game.init();
		game.spielen();
	}

	/** Spielablauf
	 */
	public void spielen() {
		int z = -1;
		int s = 2;
		Stein st = null;
		String eingabe;
		boolean player = false;
		feld.anzeigen();
		boolean nochmal = false;
		boolean ingame = true;

		do {
			ingame = true;

			while(ingame) {

				// Wenn das Spielfeld voll ist, aktuelles Spiel zu Ende
				if (feld.voll()) {
					System.out.println("Kein Zug mehr mglich. Unentschieden.");
					ingame = false;
					continue;
				}
				// Einlesen der Spalte wo der Stein reinfallen soll
				try {
					System.out.println("Spieler "+((player)?"ROT (X)":"BLAU (O)")+" ist dran.");
					System.out.println(((player)?"Rote":"Blaue")+" Steine im Topf ("+
						((player)?topf.anzahlSteine(Stein.ROT):topf.anzahlSteine(Stein.BLAU))+")");
					System.out.print("Setze Stein an Spalte: ");
					eingabe = in.readLine();
					s = Integer.parseInt(eingabe);
					if (s<0 || s >=feld.spalten()) throw new NumberFormatException();
				} catch (IOException exc) {
					System.exit(-1);
				} catch (NumberFormatException exc) {
					feld.anzeigen();
					System.out.println("Fehlerhafte Eingabe. Bitte erneut eigeben.");
					continue;			}

				// Hole Stein aus dem Topf und versuche ihn zu setzen.
				try {
					st = topf.getStein((player)?Stein.ROT:Stein.BLAU);
					z = feld.setzeStein(s,st);
				} catch (SpalteVollException exc) {
					feld.anzeigen();
					System.out.println("Spalte bereits voll. Bitte erneut eigeben.");
					continue;
				} catch (TopfLeerException exc) {
					System.out.println("Kein Zug mehr mglich. Unentschieden.");
					ingame = false;
					continue;
				}

				// prfen des gesetzten Steins auf Gewinn-Position
				if (feld.pruefeStein(s,z)) {
					feld.anzeigen();
					System.out.println("GEWONNEN hat Spieler "+((player)?"ROT (X)":"BLAU (O)"));
					ingame = false;
					continue;
				}
				// Spielerwechsel
				player = !player;
				feld.anzeigen();
			}

			System.out.println("\nNeues Spiel (J/N)");
			try {
				eingabe = in.readLine();
				if (eingabe.equalsIgnoreCase("J")) {
					nochmal = true;
					java.util.Collection c = feld.leeren();
					topf.setStein(c);
				}
			} catch (IOException exc) {
				System.exit(-1);
			}
		} while(nochmal);
	}
}