public interface Spielfeld {

	/** Anzeigen des Spielfeldes.
		*/
	public void anzeigen();

	/** Setzen eines Steines in eine Spalte.
		* @param spalte Die Spalte, in der ein Stein gesetzt werden soll.
		* @param stein Der Stein, der gesetzt werden soll.
		* @return Liefert die Zeile des gesetzten Stein zurck.
		*/
	public int setzeStein(int spalte, Stein stein);

	/** Prfen ob eine Position eine Gewinn-Position ist.
		* @param spalte Die Spalten-Position zum berprfen.
		* @param zeile Die Zeilen-Position zum berprfen.
		* @return Liefert <tt>true</tt> wenn an einer Gewinn-Position,
		*         ansonsten <tt>false</tt>.
		*/
	public boolean pruefeStein(int spalte, int zeile);

	/** Entfernt vom Spielfeld alle Steine.
		* @return Liefert eine Collection mit den Steinen zurck.
		*/
	public java.util.Collection leeren();

	/** Liefert die Anzahl der Spalten vom Spielfeld zurck.
		* @return Die Anzahl der Spalten.
		*/
	public int spalten();

	/** Liefert die Anzahl der Zeilen vom Spielfeld zurck.
		* @return Die Anzahl der Zeilen.
		*/
	public int zeilen();

	/** berpft, ob das Spielfeld vollstndig gefllt ist.
		* @return Liefert <tt>true</tt>, wenn alle Zeilen und
		*         Spalten vollstndig aufgefllt sind.
		*/
	public boolean voll();

}